program cwbase64;

// Please, don't delete this comment. \\
(*
  Copyright Owner: coltishWARE (Kevin Niehage)
  Copyright Year : 2007

  Unit   : cwbase64.dpr (platform independant)
  Version: 0.1a1

  Contact E-Mail            : development@coltishWARE.com
  Contact Mobile            : +49-(0)-177-69-4321-8
  Contact Telephone Berlin  : +49-(0)-30-69-20-96-78
  Contact Telephone Cottbus : +49-(0)-355-28925-88-17-55
  Contact Telephone Mannheim: +49-(0)-621-483-4664
*)
// Please, don't delete this comment. \\

(*
  Description:

  This unit implements a program encoding to/decoding from Base64.
*)

(*
  Change Log:

  [Version 0.1a1] (10.05.2007: initial release)
*)

{$APPTYPE CONSOLE}

uses
{$IFDEF MSWINDOWS}
  Windows,
{$ELSE MSWINDOWS}
  Libc,
{$ENDIF MSWINDOWS}
  SysUtils,
  Base64U;

const
  CParamDecodeA = '*decode';
  CParamDecodeB = '*d';
  CParamEncodeA = '*encode';
  CParamEncodeB = '*e';
  CParamHelpA   = '*help';
  CParamHelpB   = '*h';

  CRatioAfter  = 4;
  CRatioBefore = 3;

var
  VDoEncode : Boolean = true;
  VInFile   : String;
  VOutFile  : String;
  VParamInc : Byte    = 0;

procedure DoAction(const AInFile : String; const AOutFile : String; const ADoEncode : Boolean); forward;
procedure ShowHelp; forward;

procedure DoAction(const AInFile : String; const AOutFile : String; const ADoEncode : Boolean);
const
  CBufferMul = 100;
var
  LBreak     : Boolean;
  LInBuffer  : String;
  LInHandle  : LongInt;
  LInSize    : LongWord;
  LOutBuffer : String;
  LOutHandle : LongInt;
  LReadCount : LongWord;
begin
  WriteLn('InFile : ' + AInFile);
  WriteLn('OutFile: ' + AOutFile);
  if ADoEncode then
    WriteLn('Action :' + 'encode')
  else
    WriteLn('Action :' + 'decode');

  if FileExists(AInFile) then
  begin
    LInHandle := FileOpen(AInFile, fmOpenRead or fmShareDenyNone);
    if (LInHandle >= 0) then
    begin
      try
        LInSize := FileSeek(LInHandle, 0, 2);
        if (FileSeek(LInHandle, 0, 0) >= 0) then
        begin
          if FileExists(AOutFile) then
            LOutHandle := FileOpen(AOutFile, fmOpenReadWrite or fmShareDenyNone)
          else
            LoutHandle := FileCreate(AOutFile);
          if (LOutHandle >= 0) then
          begin
            try
{$IFDEF MSWINDOWS}
              FileSeek(LOutHandle, 0, 0);
              SetEndOfFile(LOutHandle);
{$ELSE MSWINDOWS}
              ftruncate(LOutHandle, 0);
{$ENDIF MSWINDOWS}

              LBreak     := false;
              LReadCount := 0;
              SetLength(LInBuffer, CBufferMul * CRatioBefore * CRatioAfter);
              while (LReadCount < LInSize) do
              begin
                if ((LInSize - LReadCount) < Length(LInBuffer)) then
                  SetLength(LInBuffer, LInSize - LReadCount);

                LBreak := (FileRead(LInHandle, LInBuffer[1], Length(LInBuffer)) <> Length(LInBuffer));
                if not(LBreak) then
                begin
                  LReadCount := LReadCount + Length(LInBuffer);

                  if ADoEncode then
                    LOutBuffer := EncBase64Encode(LInBuffer)
                  else
                    LOutBuffer := EncBase64Decode(LInBuffer);
                  LBreak := (FileWrite(LOutHandle, LOutBuffer[1], Length(LOutBuffer)) <> Length(LOutBuffer));
                end
                else
                  Break;

                if LBreak then
                  Break;
              end;

              if LBreak then
                WriteLn('an error has occured - action aborted')
              else
                WriteLn('everything fine');
            finally
              FileClose(LOutHandle);
            end;
          end;
        end;
      finally
        FileClose(LInHandle);
      end;
    end;
  end;
end;

procedure ShowHelp;
begin
  WriteLn('[<action>] <infile> [<outfile>]');
  WriteLn('');
  WriteLn('<action>: (default: encode)');
  WriteLn('  encode: "' + CParamEncodeA + '" or "' + CParamEncodeB + '"');
  WriteLn('  decode: "' + CParamDecodeA + '" or "' + CParamDecodeB + '"');
end;

begin
  WriteLn('cwbase64 - Base64-De(/En)-Coder');
  WriteLn('');

  if (ParamCount > 0) then
  begin
    if ((AnsiLowerCase(ParamStr(1)) = CParamHelpA) or
        (AnsiLowerCase(ParamStr(1)) = CParamHelpB)) then
      ShowHelp
    else
    begin
      VDoEncode := true;
      VInFile   := '';
      VOutFile  := '';
      VParamInc := 0;
      if ((AnsiLowerCase(ParamStr(1)) = CParamDecodeA) or
          (AnsiLowerCase(ParamStr(1)) = CParamDecodeB)) then
      begin
        VDoEncode := false;
        Inc(VParamInc);
      end;
      if ((AnsiLowerCase(ParamStr(1)) = CParamEncodeA) or
          (AnsiLowerCase(ParamStr(1)) = CParamEncodeB)) then
      begin
        VDoEncode := true;
        Inc(VParamInc);
      end;

      if (ParamCount >= (1 + VParamInc)) then
      begin
        if FileExists(ParamStr(1 + VParamInc)) then
        begin
          VInFile := ParamStr(1 + VParamInc);
          if (ParamCount >= (2 + VParamInc)) then
            VOutFile := ParamStr(2 + VParamInc)
          else
            VOutFile := VInFile + '.cw';

          if FileExists(VOutFile) then
            RenameFile(VOutFile, VOutFile + '.' + FloatToStr(Now));

          DoAction(VInFile, VOutFile, VDoEncode);
        end
        else
        begin
          WriteLn('infile does not exist');
        end;
      end
      else
        ShowHelp;
    end;
  end
  else
    ShowHelp;
end.

